/* VAARALLISTA!  ... eli HAUSKAA (tiettyyn pisteeseen asti..). 
 *
 * Ei saa kokeilla yhteiskäyttökoneilla! Kotikoneella MUISTA että
 * tiedostojärjestelmäsi on periaatteessa aina vaarassa, jos joudut
 * käynnistämään, eli omalla vastuullasi olet datoinesi!
 * Virtuaalikoneen käyttö helpottaa tilannetta, jos et kytke sitä
 * kovalevysi muuhun sisältöön. Suorakäyttökoneella
 * itka203-testi.it.jyu.fi voi kokeilla tätä ja mitä vain
 * turvallisessa ympäristössä. Jos kone jostain syystä kyykähtää, sen
 * voi kylmäkäynnistää etänä (kestää noin pari minuuttia). Soita
 * 040-5768507 arkisin klo 9-17, niin homma hoituu.
 *
 * Tässä esimerkissä luodaan lapsiprosesseja niin kauan kuin
 * pystyy. Jos järjestelmässä ei ole rajoitettu käyttäjien oikeuksia
 * prosessien käytössä, tässä käy lopulta niin, että määritelty
 * maksimimäärä prosesseja on täynnä, ja siinä vaiheessa tietokoneella
 * ei tee kukaan paljon mitään. Paljon ääneen kiroilua tapahtuu.
 *
 * Kaitpa, jos tämä olisi pahantahtoisen hakkerin tekosia,
 * sanottaisiin että tämä on yhdenlainen DoS eli Denial-of-service
 * -hyökkäys. Kukaan ei tee palvelimella mitään, jos joku pääsi
 * pommittamaan prosessitaulun täyteen.
 *
 * HUOM: fork()-kutsun käytön ymmärtäminen kuuluu kurssin
 * pakolliseenkin sisältöön!
 *
 */

#include<stdio.h>
#include<stdlib.h>

#include "turvavyo.h"

int main(int argc, char *argv[]){
  int pid;
  int n = 0;

  lopeta_jos_ei_turvallinen_kone();

  for(;;){
    switch (pid=fork()) {
    case 0: 
      /* Uusi prosessi jätetään odottelemaan signaalia. */
      pause();
      exit(0);
    case -1: 
      perror("fork() failed");
      break;
    default:
      printf("Tein lapsiprosessin, jonka PID on %d (yht. %d kpl) \r", pid, ++n);
    } 
  }
  return 0;
}
